=== debian/changelog ===
godot (3.0.6-2) unstable; urgency=medium

  * Switch to source format 3.0 (Closes: #914617)
  * Remove binary dependencies, thanks  Jeremy Bicha (Closes: #914618)
  * Support 32-bit architectures (Closes: #914609, #914620, #914624)

 -- Federico Ceratto <federico@debian.org>  Sat, 01 Dec 2018 21:04:44 +0000

godot (3.0.6-1) unstable; urgency=medium

  [ Federico Ceratto ]
  * Initial release (Closes: #793057)

 -- Federico Ceratto <federico@debian.org>  Sun, 26 Aug 2018 20:42:31 +0100
