=== debian/control ===
Source: godot
Section: devel
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Federico Ceratto <federico@debian.org>
Build-Depends: debhelper (>= 11~),
 ca-certificates,
 libasound2-dev,
 libenet-dev,
 libfreetype6-dev,
 libgcc-8-dev,
 libgl1-mesa-dev,
 libglu1-mesa-dev,
 libopus-dev,
 libopusfile-dev,
 libpcre2-dev,
 libpng-dev,
 libpulse-dev,
 libsquish-dev,
 libssl-dev,
 libstdc++-8-dev,
 libtheora-dev,
 libudev-dev,
 libvorbis-dev,
 libvpx-dev,
 libwebp-dev,
 libx11-dev,
 libxcursor-dev,
 libxi-dev,
 libxinerama-dev,
 libxrandr-dev,
 pkg-config,
 scons,
 zlib1g-dev
Standards-Version: 4.2.1
Homepage: https://godotengine.org
Vcs-Git: https://salsa.debian.org/debian/godot3.git
Vcs-Browser: https://salsa.debian.org/debian/godot3

Package: godot3
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: Full 2D and 3D game engine with editor
 Godot is an advanced, feature packed, multi-platform 2D and 3D game engine.
 It provides a huge set of common tools, so you can just focus on making
 your game without reinventing the wheel.

Package: godot3-runner
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: Godot game engine run-time
 Godot is an advanced, feature packed, multi-platform 2D and 3D game engine.
 This package allows games to be run from source or data-pack.

Package: godot3-server
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: Headless Godot game engine run-time
 Godot is an advanced, feature packed, multi-platform 2D and 3D game engine.
 This package provides a command-line only version of the program.
