## godot 3.2-stable

=== debian/changelog ===
godot (3.2-stable-2) unstable; urgency=medium

  * Team upload
  * Remove build-deps libgcc-8-dev, libstdc++-8-dev (Closes: #944168)
  * Clean .sconsign?.dblite because .sconsign5.dblite prevents the build
    (Closes: #954608)

 -- Juhani Numminen <juhaninumminen0@gmail.com>  Wed, 25 Mar 2020 10:49:15 +0200

godot (3.2-stable-1) unstable; urgency=medium

  * New upstream release

 -- Federico Ceratto <federico@debian.org>  Fri, 28 Feb 2020 22:22:59 +0000
