=== debian/control ===
--- 
+++ 
@@ -8,7 +8,6 @@
  libasound2-dev,
  libenet-dev,
  libfreetype6-dev,
- libgcc-8-dev,
  libgl1-mesa-dev,
  libglu1-mesa-dev,
  libopus-dev,
@@ -18,7 +17,6 @@
  libpulse-dev,
  libsquish-dev,
  libssl-dev,
- libstdc++-8-dev,
  libtheora-dev,
  libudev-dev,
  libvorbis-dev,
