=== debian/rules ===
--- 
+++ 
@@ -16,6 +16,9 @@
 	find . -iname ".a" -delete
 	find . -iname ".o" -delete
 	find . -iname ".sconsign.dblite" -delete
+	find . -name '*.o' -delete
+	rm -rf main/libmain.x11.opt.tools.64.a main/tests/libtests.x11.opt.tools.64.a
+	rm -rf config.log .sconsign?.dblite
 	rm -rf bin/
 	rm -rf enet
 	rm -rf freetype
@@ -65,7 +68,8 @@
 	echo "Installing binaries for $(BITS) bits architecture"
 	install -D -m 400 $(CURDIR)/bin/godot.x11.opt.tools.$(BITS)           $(CURDIR)/debian/godot3/usr/bin/godot3
 	install -D -m 400 $(CURDIR)/bin/godot.x11.opt.$(BITS)                 $(CURDIR)/debian/godot3-runner/usr/bin/godot3-runner
-	install -D -m 400 $(CURDIR)/bin/godot_server.server.opt.tools.$(BITS) $(CURDIR)/debian/godot3-server/usr/bin/godot3-server
-	install -D -m 444 $(CURDIR)/misc/dist/linux/godot.desktop             $(CURDIR)/debian/godot3/usr/share/applications/godot3.desktop
+	install -D -m 400 $(CURDIR)/bin/godot_server.x11.opt.tools.$(BITS) $(CURDIR)/debian/godot3-server/usr/bin/godot3-server
+	install -D -m 444 $(CURDIR)/misc/dist/linux/org.godotengine.Godot.desktop  $(CURDIR)/debian/godot3/usr/share/applications/godot3.desktop
 	sed -i 's/^Exec=.*/Exec=godot3 -p/' $(CURDIR)/debian/godot3/usr/share/applications/godot3.desktop
 	dh_auto_install
+
