## godot 3.2.3-stable

=== debian/changelog ===
godot (3.2.3-stable-1ubuntu0.1~esm1) jammy-security; urgency=medium

  * SECURITY UPDATE: Crash due to double free of variable
    - debian/patches/CVE-2019-2126.patch: Avoid double free in
      ContentEnconding
    - CVE-2019-2126
  * SECURITY UPDATE: Malformed input crash
    - debian/patches/CVE-2021-26825_26826.patch: Fix a crash in the TGA
      loader with malformed input
    - CVE-2021-26825
    - CVE-2021-26826

 -- John Breton <john.breton@canonical.com>  Tue, 17 Jun 2025 07:51:32 -0400

godot (3.2.3-stable-1build2) jammy; urgency=medium

  * No-change rebuild against latest libwebp

 -- Jeremy Bicha <jeremy.bicha@canonical.com>  Tue, 01 Feb 2022 09:19:36 -0500

godot (3.2.3-stable-1build1) jammy; urgency=medium

  * Rebuild for the new libvpx soname

 -- Sebastien Bacher <seb128@debian.org>  Wed, 17 Nov 2021 13:26:11 +0100

godot (3.2.3-stable-1) unstable; urgency=medium

  [ Federico Ceratto ]
  * New upstream release

  [ Dominik George ]
  * New upstream release
  * Drop ca-certs path patch
    + Use system_certs_path build option instead
  * Bump Standards-Version
    + No changes needed
  * Install icon (Closes: #956684)
  * Add myself to Uploaders to trak package
  * Remove .scons_env.json after scons generation in dh_clean
  * Thanks to Teckids e.V. and credativ GmbH for sponsoring the work

 -- Dominik George <natureshadow@debian.org>  Wed, 28 Oct 2020 13:56:05 +0100
