=== debian/control ===
--- 
+++ 
@@ -1,8 +1,10 @@
 Source: godot
 Section: devel
 Priority: optional
-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
-Uploaders: Federico Ceratto <federico@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Uploaders: Federico Ceratto <federico@debian.org>,
+ Dominik George <natureshadow@debian.org>
 Build-Depends: debhelper (>= 11~),
  ca-certificates,
  libasound2-dev,
@@ -30,7 +32,7 @@
  pkg-config,
  scons,
  zlib1g-dev
-Standards-Version: 4.2.1
+Standards-Version: 4.5.0
 Homepage: https://godotengine.org
 Vcs-Git: https://salsa.debian.org/debian/godot3.git
 Vcs-Browser: https://salsa.debian.org/debian/godot3
